## HANDLE SINGLE FLOW FRAMES AT A TIME.
setMethod("flowJoCompensate",
          signature(flowData="flowFrame", compMatrix="matrix"), 
          definition = function(flowData, compMatrix, verbose=FALSE) {

  if (dim(compMatrix)[1] == 0) {
    if (verbose) {
      print("      -- Bypassing a zero X zero comp matrix for this file --");
    }
    return(flowData);
  }

  maxValAdj             <- 1/max(compMatrix);     
  cols                  <- colnames(compMatrix);
  flowData              <- compensate(flowData, compMatrix);
  flowData@exprs[,cols] <- maxValAdj * flowData@exprs[,cols]; 

  return(flowData);
});



## SAME AS ABOVE, BUT NOW FOR FLOWSETS
setMethod("flowJoCompensate",
          signature(flowData = "flowSet", compMatrix="matrix"), 
          definition = function(flowData, compMatrix, verbose=FALSE) {

  results <- fsApply(flowData, flowJoCompensate, compMatrix, verbose);
  return(results);
});



