
setMethod("getWellId",
          signature(aFlowFrame = "flowFrame"), 
          definition = function(aFlowFrame) {

  wellInfo <- list(RowSymbol=NA, Column=NA);  # The actual return object
  wellId   <- "NULL"                            # Hopefully something like "B07"
  
  # First try this...
  wellId   <- as.character(keyword(aFlowFrame, 'WELL ID'));
  # Then try this...
  if (wellId == "NULL") { 
    wellId <- as.character(keyword(aFlowFrame, 'TUBE NAME')); 
  }
  # Then try this -- some FC500 files look like this
  if (wellId == "NULL") { 
    wellId <- as.character(keyword(aFlowFrame, '@TRAYROWCOL')); 
  }


  # Gasp, try looking at the file name
  if (wellId == "NULL") {
    wellId <- gsub(".*([A-P]\\d+).*", "\\1", keyword(aFlowFrame, '$FIL'), 
                   ignore.case=TRUE, perl=TRUE);
    if (length(wellId) == 0) { wellId = "NULL"; }
    if (length(grep("[A-P]\\d+", wellId, perl=TRUE, ignore.case=TRUE)) == 0) wellId = "NULL";
  }
  
  # Last ditch effort, look in the 'identifier' field...
  if (wellId == "NULL") {
    wellId <- gsub(".*([A-P]\\d+).*", "\\1", identifier(aFlowFrame), 
                   ignore.case=TRUE, perl=TRUE);
    if (length(wellId) == 0) { wellId = "NULL"; }
    if (length(grep("[A-P]\\d+", wellId, perl=TRUE, ignore.case=TRUE)) == 0) wellId = "NULL";
  }
  
  # Standard failure return
  if (wellId == "NULL") { 
    return(wellInfo); 
    
  # Backup safety to be sure above regular expressions didn't pick up something funny.  
  } else if (length(grep("\\b[A-Za-z]{1,1}\\d{1,3}\\b", wellId, perl=TRUE)) == 0) {
    return(wellInfo);
    
  } else {  
    wellInfo$RowSymbol = toupper(substr(wellId, 1,1));
    wellInfo$Column    = as.numeric(substr(wellId, 2, nchar(wellId)));    
  }
  return(wellInfo);
});
  

