\name{flowJoCompensate-methods}
\docType{methods}
\alias{flowJoCompensate}
\alias{flowJoCompensate-methods}
\alias{flowJoCompensate,flowFrame,matrix-method}
\alias{flowJoCompensate,flowSet,matrix-method}
\title{ Compensate flow cytometry data the same way as FlowJo does }

\description{
 FlowJo currently implements its compensation/spillover matrices
differently than they are implemented in the general flow cytometry
community. Currently, in order to obtain similar results (e.g. MFIs
and cell counts) between FlowJo and flowCore, it is necessary to apply
the compensation matrix to the data in the usual way (ie. via {}``compensate''),
and then to divide all of the observed data by the maximum of the
values in the compensation matrix. The flowFlowJo package implements
a method, flowJoCompensate, to automatically take care of this issue.
}

\section{Methods}{
\describe{

\item{flowData = "flowFrame", compMatrix = "matrix"}{ 
  flowJoCompensate can take in either a flowFrame or a flowSet as well as a numerical matrix of compensation values. 
  }

\item{flowData = "flowSet", compMatrix = "matrix"}{ 
  flowJoCompensate can take in either a flowFrame or a flowSet as well as a numerical matrix of compensation values. }
  } 
}

\keyword{methods}
